/*
iio.js
Version 1.4.1-beta

iio.js is licensed under the BSD 2-clause Open Source license

Copyright (c) 2018, Sebastian Bierman-Lytle
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list 
of conditions and the following disclaimer.

Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or other 
materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.
*/
iio={},iio.apps=[],iio.start=function(a,b,c){var d=iio.canvas.prep(b,c);return a instanceof Array?new iio.App(d,a[0],a[1]):new iio.App(d,a)},iio.stop=function(a){if(a)a.stop();else for(var b=0;b<iio.apps.length;b++)iio.apps[b].stop()},iio.script=function(){if("undefined"!=typeof CoffeeScript){var scripts=Array.prototype.slice.call(document.getElementsByTagName("script")),iioScripts=scripts.filter(function(a){return"text/iioscript"===a.type});iioScripts.forEach(function(script){var xhr=new XMLHttpRequest;xhr.open("GET",script.src,!0),xhr.onreadystatechange=function(){if(4===xhr.readyState&&(200===xhr.status||0===xhr.status)){var appName=script.src.split("/").pop().replace(/\.[^\/.]+$/,"");iio.scripts[appName]=eval("(function() {\nreturn function(app, settings) {\n"+CoffeeScript.compile(xhr.responseText,{bare:!0})+"}\n})()"),window.dispatchEvent(new Event("iioscript:"+appName))}},xhr.send(null)})}},iio.inherit=function(a,b){function c(){}var d=a;c.prototype=b.prototype,a.prototype=new c,a.prototype.constructor=d},iio.merge=function(a,b){for(var c in b)a[c]=b[c];return a},iio.merge_args=function(a){if(a){for(var b={},c=0;c<a.length;c++)b=iio.merge(b,a[c]);return b}return a},iio.addEvent=function(a,b,c,d){return a.addEventListener?(a.addEventListener(b,c,d),!0):!!a.attachEvent&&(a.attachEvent("on"+b,c),!0)},iio.set=function(a,b){a.forEach(function(a){a.set(b)})},iio.random=function(a,b){return a=a||0,b=0===b||void 0!==b?b:1,Math.random()*(b-a)+a},iio.randomInt=function(a,b){return Math.floor(iio.random(a,b))},iio.centroid=function(a){for(var b,c,d=0;d<a.length;d++)b+=a[d].x,c+=a[d].y;return new iio.Vector(b/a.length,c/a.length)},iio.specVec=function(a,b){for(var c=a[0],d=0;d<a.length;d++)b(c,a[d])&&(c=a[d]);return c},iio.load=function(a,b){var c=new Image;return c.src=a,c.onload=b,c},iio.read=function(a,b){var c=new XMLHttpRequest;c.open("GET",a,!0),c.onreadystatechange=function(){if(4===c.readyState&&(200===c.status||0==c.status))return b(c.responseText)},c.send(null)},iio.loop=function(a,b,c){function d(){var c=(new Date).getTime();if(void 0===b.last)var e=!0;var f=Math.floor(Math.max(0,1e3/a-(c-(b.last||a))));b.last=c+f;var g;if(void 0===e&&(g=void 0===b.fn?b.o._update(b.o,f):iio.is.fn(b.fn)?b.fn(b.o,b,f):b.fn._update(b,f),b.o.app.draw()),"boolean"==typeof g&&!g)return b.fn&&b.fn.looping?b.fn.looping=!1:b.o&&b.o.looping&&(b.o.looping=!1),0;void 0===g?b.id=window.setTimeout(d,f):(a=g,b.id=window.setTimeout(d,1e3/g))}function e(){var a;if(void 0===b.fn?b.o.draw():iio.is.fn(b.fn)?b.fn(b.o):(a=b.fn._update(),b.fn.draw()),b.o.app.draw(),"boolean"==typeof a&&!a)return void(b.fn&&b.fn.looping?b.fn.looping=!1:b.o&&b.o.looping&&(b.o.looping=!1));b.id=window.requestAnimationFrame(e)}return iio.is.number(a)||void 0===window.requestAnimationFrame||!a.af?(void 0!==a.af&&void 0===a.fps?(b,b=a,a=60):iio.is.number(a)||(b=a,a=a.fps),b.id=window.setTimeout(d,1e3/a),b.id):(b,b=a,b.id=window.requestAnimationFrame(e),b.id)},iio.cancelLoop=function(a){window.clearTimeout(a),window.cancelAnimationFrame(a)},iio.cancelLoops=function(a,b){a.loops&&a.loops.forEach(function(a){iio.cancelLoop(a.id)}),a.mainLoop&&iio.cancelLoop(a.mainLoop.id),void 0===b&&a.objs&&a.objs.forEach(function(a){iio.cancelLoops(a)})},iio.requestTimeout=function(a,b,c,d){var e=(new Date).getTime(),f=Math.max(0,1e3/a-(e-b));d[0].fsID=setTimeout(function(){c(e+f,d)},f),b=e+f},iio.resize=function(){iio.apps.forEach(function(a){a.canvas.fullscreen&&(window.jQuery?(a.canvas.width=$(window).width(),a.canvas.height=$(window).height()):(a.canvas.width=window.innerWidth,a.canvas.height=window.innerHeight)),a.width=a.canvas.width,a.height=a.canvas.height,a.center.x=a.canvas.width/2,a.center.y=a.canvas.height/2,a.onResize&&a.onResize(),a.script&&a.script.onResize&&a.script.onResize(),a.draw()})},iio.prep_input=function(){window.onresize=iio.resize,iio.addEvent(window,"keydown",function(a){var b=iio.key.string(a);iio.apps.forEach(function(c){c.onKeyDown&&c.onKeyDown(a,b)})}),iio.addEvent(window,"keyup",function(a){var b=iio.key.string(a);iio.apps.forEach(function(c){c.onKeyUp&&c.onKeyUp(a,b)})}),iio.addEvent(window,"scroll",function(a){iio.apps.forEach(function(a){var b=a.canvas.getBoundingClientRect();a.pos={x:b.left,y:b.top},a.onScroll&&a.onScroll(e,k)})})},iio.prep_input(),Array.prototype.insert=function(a,b){return this.splice(a,0,b),this},void 0===Function.prototype.name&&Object.defineProperty(Function.prototype,"name",{get:function(){return/function ([^(]*)/.exec(this+"")[1]}}),iio.is={fn:function(a){return"function"==typeof a},number:function(a){return"number"==typeof a},string:function(a){return"string"==typeof a||a instanceof String},filetype:function(a,b){return b.some(function(b){return-1!==a.indexOf("."+b)})},image:function(a){return this.filetype(a,["png","jpg","gif","tiff"])},sound:function(a){return this.filetype(a,["wav","mp3","aac","ogg"])},between:function(a,b,c){if(c<b){var d=b;b=c,c=d}return a>=b&&a<=c},Polygon:function(a){return a instanceof iio.Polygon||a instanceof iio.Rectangle||a instanceof iio.Text},Circle:function(a){return a instanceof iio.Ellipse&&(!a.vRadius||a.radius===a.vRadius)},Quad:function(a){return a instanceof iio.Quad||a instanceof iio.App||a instanceof iio.Grid}},iio.convert={property:{color:function(a,b){a[b]&&iio.is.string(a[b])&&(a[b]=iio.convert.color(a[b]))},vector:function(a,b){a[b]&&(a[b]=iio.convert.vector(a[b]))},vectors:function(a,b){a[b]&&(a[b]=iio.convert.vectors(a[b]))}},color:function(a){return iio.Color[a.toLowerCase()]()},vector:function(a){return a instanceof Array?new iio.Vector(a):a instanceof iio.Vector?a:new iio.Vector(a,a)},vectors:function(a){for(var b=0;b<a.length;b++)a[b]=iio.convert.vector(a[b]);return a}},iio.html={defaults:{tag:"div",style:{position:"fixed",top:"0",left:"0",margin:"0",padding:"0"}},create:function(a){var b=document.createElement(a.tag||iio.html.defaults.tag);b.innerHTML=a.innerHTML;for(var c in iio.html.defaults.style)b.style[c]=iio.html.defaults.style[c];for(var c in a.style)b.style[c]=a.style[c];return b}},iio.key={string:function(a){return iio.keys[a.keyCode]},code_is:function(a,b){a instanceof Array||(a=[a]);var c=iio.key.string(b);return a.some(function(a){return a===c})}},iio.keys={8:"backspace",9:"tab",13:"enter",16:"shift",17:"ctrl",18:"alt",19:"pause",20:"caps lock",27:"escape",32:"space",33:"page up",34:"page down",35:"end",36:"home",37:"left arrow",38:"up arrow",39:"right arrow",40:"down arrow",45:"insert",46:"delete",48:"0",49:"1",50:"2",51:"3",52:"4",53:"5",54:"6",55:"7",56:"8",57:"9",65:"a",66:"b",67:"c",68:"d",69:"e",70:"f",71:"g",72:"h",73:"i",74:"j",75:"k",76:"l",77:"m",78:"n",79:"o",80:"p",81:"q",82:"r",83:"s",84:"t",85:"u",86:"v",87:"w",88:"x",89:"y",90:"z",91:"left window",92:"right window",93:"select key",96:"n0",97:"n1",98:"n2",99:"n3",100:"n4",101:"n5",102:"n6",103:"n7",104:"n8",105:"n9",106:"multiply",107:"add",109:"subtract",110:"dec",111:"divide",112:"f1",113:"f2",114:"f3",115:"f4",116:"f5",117:"f6",118:"f7",119:"f8",120:"f9",121:"f10",122:"f11",123:"f12",144:"num lock",156:"scroll lock",186:"semi-colon",187:"equal",188:"comma",189:"dash",190:"period",191:"forward slash",192:"grave accent",219:"open bracket",220:"back slash",221:"close bracket",222:"single quote"},iio.canvas={create:function(a,b){var c=document.createElement("canvas");return a?(c.style.position="relative",c.width=a,c.height=b):(c.margin=0,c.padding=0,c.style.position="fixed",c.style.left=0,c.style.top=0,c.fullscreen=!0,window.jQuery?(c.width=$(document).width(),c.height=$(document).height()):(c.width=window.innerWidth,c.height=window.innerHeight)),c},prep:function(a,b){var c;return a?(c=document.getElementById(a))||("CANVAS"===a.tagName?c=a:(iio.is.number(a)||a.x)&&(c=iio.canvas.create(a.x||a,a.y||a),b?b.appendChild(c):document.body.appendChild(c))):(iio.canvas.prep_fullscreen(),c=iio.canvas.create(),document.body.appendChild(c)),c},prep_fullscreen:function(){document.body.style.margin=0,document.body.style.padding=0},prep_input:function(a){function b(a,b,c){var d=a.parent.eventVector(b);a.parent[c]&&a.parent[c](a.parent,b,d),a.parent.objs.forEach(function(e,f){if(0!==f&&(d=a.parent.eventVector(b)),e.contains&&e.contains(d)&&e[c])if(e.cellAt){var g=e.cellAt(d);e[c](e,b,d,g)}else e[c](e,b,d)},a)}function c(b,c){a[b]?(a["_"+b]=a[b],a[b]=function(a){c(a),this["_"+b](a)}):a[b]=c}c("onclick",function(c){b(a,c,"onClick")}),c("onmousedown",function(c){b(a,c,"onMouseDown"),b(a,c,"onInputDown")}),c("onmouseup",function(c){b(a,c,"onMouseUp"),b(a,c,"onInputUp")}),c("touchstart",function(c){b(a,c,"onInputDown")}),c("touchend",function(c){b(a,c,"onInputUp")})}},iio.collision={check:function(a,b){if(!a||!b)return!1;if(iio.is.Quad(a)){if(iio.is.Quad(b))return iio.collision.rectXrect(a,b);if(iio.is.Polygon(b))return iio.collision.polyXpoly(a,b);if(b instanceof iio.Line)return iio.collision.polyXline(a,b);if(iio.is.Circle(b))return iio.collision.polyXcircle(a,b)}else if(iio.is.Polygon(a)){if(iio.is.Polygon(b))return iio.collision.polyXpoly(a,b);if(iio.is.Quad(b))return iio.collision.polyXpoly(a,b);if(b instanceof iio.Line)return iio.collision.polyXline(b,a);if(iio.is.Circle(b))return iio.collision.polyXcircle(a,b)}else if(iio.is.Circle(a)){if(iio.is.Circle(b))return iio.collision.circleXcircle(a,b);if(b instanceof iio.Ellipse)return iio.collision.ellipseXellipse(a,b);if(iio.is.Polygon(b)||iio.is.Quad(b))return iio.collision.polyXcircle(b,a);if(b instanceof iio.Line)return iio.collision.circleXline(a,b)}else if(a instanceof iio.Ellipse){if(b instanceof iio.Ellipse||iio.is.Circle(b))return iio.collision.ellipseXellipse(a,b)}else if(a instanceof iio.Line){if(b instanceof iio.Line)return iio.collision.lineXline(a,b);if(b instanceof iio.Polygon)return iio.collision.polyXline(b,a);if(iio.is.Polygon(b))return iio.collision.polyXline(b,a);if(iio.is.Circle(b))return iio.collision.circleXline(b,a)}},lineXline:function(a,b){var c=a.trueVs(),d=b.trueVs();return iio.collision.lineCline(c[0],c[1],d[0],d[1])},lineCline:function(a,b,c,d){var e,f=(b.y-a.y)/(b.x-a.x),g=(d.y-c.y)/(d.x-c.x),h=f,i=a.x,j=a.y,k=!isFinite(f),l=!isFinite(g);if(k||l){if(k&&l)return a.x===c.x&&(iio.is.between(a.y,c.y,d.y)||iio.is.between(b.y,c.y,d.y)||iio.is.between(c.y,a.y,b.y)||iio.is.between(d.y,a.y,b.y));k?(e=a.x,h=g,i=c.x,j=c.y):e=c.x}else if(e=(f*a.x-g*c.x-a.y+c.y)/(f-g),!isFinite(e))return iio.is.between(a.x,c.x,d.x)&&iio.is.between(a.y,c.y,d.y)||iio.is.between(b.x,c.x,d.x)&&iio.is.between(b.y,c.y,d.y)||iio.is.between(c.x,a.x,b.x)&&iio.is.between(c.y,a.y,b.y)||iio.is.between(d.x,a.x,b.x)&&iio.is.between(d.y,a.y,b.y);var m=h*(e-i)+j;return!!(iio.is.between(e,a.x,b.x)&&iio.is.between(e,c.x,d.x)&&iio.is.between(m,a.y,b.y)&&iio.is.between(m,c.y,d.y))},rectXrect:function(a,b){return a.left()<b.right()&&a.right()>b.left()&&a.top()<b.bottom()&&a.bottom()>b.top()},circleXcircle:function(a,b){return a.pos.dist(b.pos)<a.radius+b.radius},polyXpoly:function(a,b){var c,d=a.trueVs(),e=b.trueVs();for(c=0;c<d.length;c++)if(b.contains(d[c]))return!0;for(c=0;c<e.length;c++)if(a.contains(e[c]))return!0;var f,g,h;for(c=0;c<d.length;c++)for(f=iio.Vector.add(d[c],a.pos),g=iio.Vector.add(d[(c+1)%d.length],a.pos),h=0;h<e.length;h++)if(iio.collision.lineCline(f,g,iio.Vector.add(e[h],b.pos),iio.Vector.add(e[(h+1)%e.length],b.pos)))return!0;return!1},polyXcircle:function(a,b){for(var c=a.trueVs(),d=0;d<c.length;d++)if(b.contains(c[d]))return!0;for(var e=1,d=0;d<c.length;d++,e=d+1)if(e===c.length&&(e=0),iio.collision.circleCline(b,c[d],c[e]))return!0;return!1},polyXline:function(a,b){for(var c,d,e=a.trueVs(),f=b.trueVs(),g=0;g<e.length;g++)if(c=e[g],d=e[(g+1)%e.length],iio.collision.lineCline(f[0],f[1],c,d))return!0;return!1},circleXline:function(a,b){var c=b.trueVs();return iio.collision.circleCline(a,c[0],c[1])},circleCline:function(a,b,c){var d=(c.x-b.x)*(c.x-b.x)+(c.y-b.y)*(c.y-b.y),e=2*((c.x-b.x)*(b.x-a.pos.x)+(c.y-b.y)*(b.y-a.pos.y)),f=a.pos.x*a.pos.x+a.pos.y*a.pos.y+b.x*b.x+b.y*b.y-2*(a.pos.x*b.x+a.pos.y*b.y)-a.radius*a.radius,g=e*e-4*d*f;if(g>0){var h=Math.sqrt(g),i=(-e+h)/(2*d),j=(-e-h)/(2*d);if(!(i<0||i>1)||!(j<0||j>1))return!0}return!1},ellipse_options:function(a,b){var c=a.maxCollisionIterations||10;b.maxCollisionIterations&&b.maxCollisionIterations>c&&(c=b.maxCollisionIterations);var d=a.numCollisionNodes||10;b.numCollisionNodes&&b.numCollisionNodes>d&&(d=b.numCollisionNodes);for(var e=[],f=[],g=0;g<=c;g++)e[g]=.5/Math.cos(4*Math.acos(0)/d),f[g]=.5/(Math.cos(2*Math.acos(0)/d)*Math.cos(2*Math.acos(0)/d));return{maxIterations:c,innerPolyCoef:e,outerPolyCoef:f}},ellipseXellipse:function(a,b){var c=a.pos.x,d=a.pos.y,e=b.pos.x,f=b.pos.y,g=a.localizeRotation(new iio.Vector(a.radius,0),!0),h=b.localizeRotation(new iio.Vector(b.radius,0),!0),i=g.x,j=g.y,k=h.x,l=h.y,m=(a.vRadius||a.radius)/a.radius,n=(b.vRadius||b.radius)/b.radius,o=iio.collision.ellipse_options(a,b),p=n*n*(k*k+l*l)*(k*k+l*l)*(k*k+l*l),q=n*k*(l*(f-d)+k*(e-c))-l*(k*(f-d)-l*(e-c)),r=n*l*(l*(f-d)+k*(e-c))+k*(k*(f-d)-l*(e-c)),s=i;i=n*k*(l*j+k*i)-l*(k*j-l*i);var t=j;j=n*l*(l*j+k*s)+k*(k*j-l*s);var u=n*k*(l*(s*m)-k*t*m)-l*(k*(s*m)+l*t*m),v=n*l*(l*(s*m)-k*t*m)+k*(k*(s*m)+l*t*m);return i*r-j*q<0&&(q=-q,r=-r),(i-q)*(i-q)+(j-r)*(j-r)<=p||((i+q)*(i+q)+(j+r)*(j+r)<=p||((u-q)*(u-q)+(v-r)*(v-r)<=p||((u+q)*(u+q)+(v+r)*(v+r)<=p||(q*(v-j)+r*(i-u)<=v*i-u*j&&r*(i+u)-q*(j+v)<=v*i-u*j||(q*(i-u)-r*(v-j)>u*(i-u)-v*(v-j)&&q*(i-u)-r*(v-j)<i*(i-u)-j*(v-j)&&(q*(v-j)+r*(i-u)-v*i+u*j)*(q*(v-j)+r*(i-u)-v*i+u*j)<=p*((i-u)*(i-u)+(j-v)*(j-v))||(q*(i+u)+r*(j+v)>-i*(i+u)-j*(j+v)&&q*(i+u)+r*(j+v)<u*(i+u)+v*(j+v)&&(r*(i+u)-q*(j+v)-v*i+u*j)*(r*(i+u)-q*(j+v)-v*i+u*j)<=p*((i+u)*(i+u)+(j+v)*(j+v))||((u-i-q)*(u-i-q)+(v-j-r)*(v-j-r)<=p?iio.collision.iterate(o,q,r,u,v,-i,-j,p):(u+i-q)*(u+i-q)+(v+j-r)*(v+j-r)<=p?iio.collision.iterate(o,q,r,i,j,u,v,p):(i-u-q)*(i-u-q)+(j-v-r)*(j-v-r)<=p?iio.collision.iterate(o,q,r,-u,-v,i,j,p):(-i-u-q)*(-i-u-q)+(-j-v-r)*(-j-v-r)<=p?iio.collision.iterate(o,q,r,-i,-j,-u,-v,p):i*r-j*q<i*v-j*u&&Math.abs(u*r-v*q)<v*i-u*j?u*r-v*q>0?iio.collision.iterate(o,q,r,u,v,-i,-j,p):iio.collision.iterate(o,q,r,i,j,u,v,p):i*q+j*r>i*(u-i)+j*(v-j)&&i*q+j*r<i*(u+i)+j*(v+j)&&(i*r-j*q-v*i+u*j)*(i*r-j*q-v*i+u*j)<p*(i*i+j*j)?i*q+j*r>i*u+j*v?iio.collision.iterate(o,q,r,i,j,u,v,p):iio.collision.iterate(o,q,r,u,v,-i,-j,p):(u*r-v*q<0&&(q=-q,r=-r),u*q+v*r>-u*(i+u)-v*(j+v)&&u*q+v*r<u*(u-i)+v*(v-j)&&(u*r-v*q-v*i+u*j)*(u*r-v*q-v*i+u*j)<p*(u*u+v*v)&&(u*q+v*r>-u*i-v*j?iio.collision.iterate(o,q,r,u,v,-i,-j,p):iio.collision.iterate(o,q,r,-i,-j,-u,-v,p))))))))))},iterate:function(a,b,c,d,e,f,g,h){for(var i=1;i<=a.maxIterations;i++){var j=(d+f)*a.innerPolyCoef[i],k=(e+g)*a.innerPolyCoef[i],l=b-j,m=c-k;if(l*l+m*m<=h)return!0;var n=f-j,o=g-k;if(l*n+m*o>=0&&l*n+m*o<=n*n+o*o&&(m*n-l*o>=0||h*(n*n+o*o)>=(m*n-l*o)*(m*n-l*o)))return!0;var p=d-j,q=e-k;if(l*p+m*q>=0&&l*p+m*q<=p*p+q*q&&(m*p-l*q<=0||h*(p*p+q*q)>=(m*p-l*q)*(m*p-l*q)))return!0;var r=(d+j)*a.outerPolyCoef[i],s=(e+k)*a.outerPolyCoef[i];if((r-b)*(r-b)+(s-c)*(s-c)<h)f=j,g=k;else{var t=j-r+j,u=k-s+k;if(!((t-b)*(t-b)+(u-c)*(u-c)<h)){var v=r-j,w=s-k;if(m*v-l*w<=0||h*(v*v+w*w)>(m*v-l*w)*(m*v-l*w))if(l*v+m*w>0){if(Math.abs(l*v+m*w)<=v*v+w*w||(b-r)*(d-r)+(c-s)*(e-s)>=0){f=j,g=k;continue}}else if(-(l*v+m*w)<=v*v+w*w||(b-t)*(f-t)+(c-u)*(g-u)>=0){d=j,e=k;continue}return!1}d=j,e=k}}return!1}},iio.Interface=function(){this.Interface.apply(this,arguments)},iio.Interface.prototype.Interface=function(){this.set(arguments[0],!0)},iio.Interface.prototype.set=function(){for(var a in arguments[0])this[a]=arguments[0][a];return this.convert_props&&this.convert_props(),this},iio.Interface.prototype.clone=function(){return new this.constructor(this)},iio.Interface.prototype.toString=function(){var a="";for(var b in this)this[b]instanceof Array?a+=b+" = Array["+this[b].length+"]\n":"function"!=typeof this[b]&&"_super"!=b&&(a+=b+" = "+this[b]+"\n");return a},iio.Vector=function(){this.Vector.apply(this,arguments)},iio.inherit(iio.Vector,iio.Interface),iio.Vector.prototype._super=iio.Interface.prototype,iio.Vector.prototype.Vector=function(a,b){a instanceof Array?(this.x=a[0]||0,this.y=a[1]||0):a&&a.x?(this.x=a.x||0,this.y=a.y||0):(this.x=a||0,this.y=b||0)},iio.Vector.prototype.clone=function(){return new iio.Vector(this.x,this.y)},iio.Vector.vs=function(a){var b=[];a instanceof Array||(a=[a]);for(var c=0;c<a.length;c++)void 0!==a[c].x?b.push(a[c]):(b.push({x:a[c],y:a[c+1]}),c++);return b},iio.Vector.leftmost=function(a){return iio.specVec(a,function(a,b){return a.x>b.x}).x},iio.Vector.rightmost=function(a){return iio.specVec(a,function(a,b){return a.x<b.x}).x},iio.Vector.highest=function(a){return iio.specVec(a,function(a,b){return a.y>b.y}).y},iio.Vector.lowest=function(a){return iio.specVec(a,function(a,b){return a.y<b.y}).y},iio.Vector.add=function(){var a=new iio.Vector;for(var b in arguments)a.x+=b.x,a.y+=b.y;return a},iio.Vector.sub=function(){for(var a=arguments[0].clone(),b=1;b<arguments.length;b++)a.x-=arguments[b].x,a.y-=arguments[b].y;return a},iio.Vector.mult=function(a,b){var c=a.clone();for(var d in a)c[d]*=b;return c},iio.Vector.div=function(a,b){var c=a.clone();for(var d in b)c[d]&&(c[d]/=b[d]);return c},iio.Vector.length=function(a,b){return void 0!==a.x?Math.sqrt(a.x*a.x+a.y*a.y):Math.sqrt(a*a+b*b)},iio.Vector.normalize=function(a,b){return new iio.Vector(a,b).normalize()},iio.Vector.dot=function(a,b,c,d){return void 0!==a.x?void 0!==b.x?a.x*b.x+a.y*b.y:a.x*b+a.y*c:void 0!==c.x?a*c.x+b*c.y:a*c+b*d},iio.Vector.dist=function(a,b){return Math.sqrt(Math.pow(b.x-a.x,2)+Math.pow(b.y-a.y,2))},iio.Vector.lerp=function(a,b,c,d,e){return void 0!==a.x?new iio.Vector(a).lerp(b,c,d):new iio.Vector(a,b).lerp(c,d,e)},iio.Vector.rotate=function(a,b,c){if(void 0!==a.x&&(c=b,b=a.y,a=a.x),void 0===c||0==c)return new iio.Vector(a,b);var d=a*Math.cos(c)-b*Math.sin(c),e=b*Math.cos(c)+a*Math.sin(c);return new iio.Vector(d,e)},iio.Vector.prototype.add=function(a,b){return void 0!==a.x?(this.x+=a.x,this.y+=a.y):(this.x+=a,this.y+=b),this},iio.Vector.prototype.sub=function(a,b){return void 0!==a.x?(this.x-=a.x,this.y-=a.y):(this.x-=a,this.y-=b),this},iio.Vector.prototype.mult=function(a){return this.x*=a,this.y*=a,this},iio.Vector.prototype.div=function(a){return this.x/=a,this.y/=a,this},iio.Vector.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y)},iio.Vector.prototype.normalize=function(){return this.div(this.length())},iio.Vector.prototype.dot=function(a,b){return void 0!==a.x?this.x*a.x+this.y*a.y:this.x*a+this.y*b},iio.Vector.prototype.equals=function(a,b){return a.x?this.x===a.x&&this.y===a.y:this.x===x&&this.y===b},iio.Vector.prototype.dist=function(a,b){return void 0!==a.x?Math.sqrt((a.x-this.x)*(a.x-this.x)+(a.y-this.y)*(a.y-this.y)):Math.sqrt((x-this.x)*(x-this.x)+(b-this.y)*(b-this.y))},iio.Vector.prototype.lerp=function(a,b,c){return void 0!==a.x?this.add(iio.Vector.sub(a,this).mult(b)):this.add(iio.Vector.sub(a,b,this).mult(c)),this},iio.Vector.prototype.rotate=function(a){if(!a)return this;var b=this.x,c=this.y;return this.x=b*Math.cos(a)-c*Math.sin(a),this.y=c*Math.cos(a)+b*Math.sin(a),this},iio.Color=function(){this.Color.apply(this,arguments)},iio.inherit(iio.Color,iio.Interface),iio.Color.prototype._super=iio.Interface.prototype,iio.Color.prototype.Color=function(a,b,c,d){if(iio.is.string(a)&&void 0===typeof c&&void 0===typeof d)if(iio.Color[a]){var e=new iio.Color[a];this.r=e.r,this.g=e.g,this.b=e.b,this.a=e.a}else{var f=iio.Color.hexToRgb(a);d=b,a=f.r,b=f.g,c=f.b}else this.r=a||0,this.g=b||0,this.b=c||0,this.a=d||1;return this},iio.Color.invert=function(a){return new iio.Color(255-a.r,255-a.g,255-a.b,a.a)},iio.Color.random=function(){return new iio.Color(iio.randomInt(0,255),iio.randomInt(0,255),iio.randomInt(0,255))},iio.Color.hexToRgb=function(a){var b=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;a=a.replace(b,function(a,b,c,d){return b+b+c+c+d+d});var c=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(a);return c?{r:parseInt(c[1],16),g:parseInt(c[2],16),b:parseInt(c[3],16)}:null},iio.Color.rgbToHex=function(a,b,c){function d(a){var b=a.toString(16);return 1===b.length?"0"+b:b}return"#"+d(a)+d(b)+d(c)},iio.Color.prototype.clone=function(){return new iio.Color(this.r,this.g,this.b,this.a)},iio.Color.prototype.rgbaString=function(){return"rgba("+this.r+","+this.g+","+this.b+","+this.a+")"},iio.Color.prototype.hexString=function(){return iio.Color.rgbToHex(this.r,this.g,this.b)},iio.Color.prototype.invert=function(){return this.r=255-this.r,this.g=255-this.g,this.b=255-this.b,this},iio.Color.prototype.randomize=function(a){return this.r=iio.randomInt(0,255),this.g=iio.randomInt(0,255),this.b=iio.randomInt(0,255),a&&(this.a=iio.random()),this},iio.Color.transparent=function(){return new iio.Color(0,0,0,0)},iio.Color.iioblue=function(){return new iio.Color(0,186,255)},iio.Color.aliceblue=function(){return new iio.Color(240,248,255)},iio.Color.antiquewhite=function(){return new iio.Color(250,235,215)},iio.Color.aqua=function(){return new iio.Color(0,255,255)},iio.Color.aquamarine=function(){return new iio.Color(127,255,212)},iio.Color.azure=function(){return new iio.Color(240,255,255)},iio.Color.beige=function(){return new iio.Color(245,245,220)},iio.Color.bisque=function(){return new iio.Color(255,228,196)},iio.Color.black=function(){return new iio.Color(0,0,0)},iio.Color.blanchedalmond=function(){return new iio.Color(255,235,205)},iio.Color.blue=function(){return new iio.Color(0,0,255)},iio.Color.blueviolet=function(){return new iio.Color(138,43,226)},iio.Color.brown=function(){return new iio.Color(165,42,42)},iio.Color.burlywood=function(){return new iio.Color(222,184,135)},iio.Color.cadetblue=function(){return new iio.Color(95,158,160)},iio.Color.chartreuse=function(){return new iio.Color(127,255,0)},iio.Color.chocolate=function(){return new iio.Color(210,105,30)},iio.Color.coral=function(){return new iio.Color(255,127,80)},iio.Color.cornflowerblue=function(){return new iio.Color(100,149,237)},iio.Color.cornsilk=function(){return new iio.Color(255,248,220)},iio.Color.crimson=function(){return new iio.Color(220,20,60)},iio.Color.cyan=function(){return new iio.Color(0,255,255)},iio.Color.darkblue=function(){return new iio.Color(0,0,139)},iio.Color.darkcyan=function(){return new iio.Color(0,139,139)},iio.Color.darkgoldenrod=function(){return new iio.Color(184,134,11)},iio.Color.darkgray=function(){return new iio.Color(169,169,169)},iio.Color.darkgreen=function(){return new iio.Color(0,100,0)},iio.Color.darkgrey=function(){return new iio.Color(169,169,169)},iio.Color.darkkhaki=function(){return new iio.Color(189,183,107)},iio.Color.darkmagenta=function(){return new iio.Color(139,0,139)},iio.Color.darkolivegreen=function(){return new iio.Color(85,107,47)},iio.Color.darkorange=function(){return new iio.Color(255,140,0)},iio.Color.darkorchid=function(){return new iio.Color(153,50,204)},iio.Color.darkred=function(){return new iio.Color(139,0,0)},iio.Color.darksalmon=function(){return new iio.Color(233,150,122)},iio.Color.darkseagreen=function(){return new iio.Color(143,188,143)},iio.Color.darkslateblue=function(){return new iio.Color(72,61,139)},iio.Color.darkslategray=function(){return new iio.Color(47,79,79)},iio.Color.darkslategrey=function(){return new iio.Color(47,79,79)},iio.Color.darkturquoise=function(){return new iio.Color(0,206,209)},iio.Color.darkviolet=function(){return new iio.Color(148,0,211)},iio.Color.deeppink=function(){return new iio.Color(255,20,147)},iio.Color.deepskyblue=function(){return new iio.Color(0,191,255)},iio.Color.dimgray=function(){return new iio.Color(105,105,105)},iio.Color.dimgrey=function(){return new iio.Color(105,105,105)},iio.Color.dodgerblue=function(){return new iio.Color(30,144,255)},iio.Color.firebrick=function(){return new iio.Color(178,34,34)},iio.Color.floralwhite=function(){return new iio.Color(255,250,240)},iio.Color.forestgreen=function(){return new iio.Color(34,139,34)},iio.Color.fuchsia=function(){return new iio.Color(255,0,255)},iio.Color.gainsboro=function(){return new iio.Color(220,220,220)},iio.Color.ghostwhite=function(){return new iio.Color(248,248,255)},iio.Color.gold=function(){return new iio.Color(255,215,0)},iio.Color.goldenrod=function(){return new iio.Color(218,165,32)},iio.Color.gray=function(){return new iio.Color(128,128,128)},iio.Color.green=function(){return new iio.Color(0,128,0)},iio.Color.greenyellow=function(){return new iio.Color(173,255,47)},iio.Color.grey=function(){return new iio.Color(128,128,128)},iio.Color.honeydew=function(){return new iio.Color(240,255,240)},iio.Color.hotpink=function(){return new iio.Color(255,105,180)},iio.Color.indianred=function(){return new iio.Color(205,92,92)},iio.Color.indigo=function(){return new iio.Color(75,0,130)},iio.Color.ivory=function(){return new iio.Color(255,255,240)},iio.Color.khaki=function(){return new iio.Color(240,230,140)},iio.Color.lavender=function(){return new iio.Color(230,230,250)},iio.Color.lavenderblush=function(){return new iio.Color(255,240,245)},iio.Color.lawngreen=function(){return new iio.Color(124,252,0)},iio.Color.lemonchiffon=function(){return new iio.Color(255,250,205)},iio.Color.lightblue=function(){return new iio.Color(173,216,230)},iio.Color.lightcoral=function(){return new iio.Color(240,128,128)},iio.Color.lightcyan=function(){return new iio.Color(224,255,255)},iio.Color.lightgoldenrodyellow=function(){return new iio.Color(250,250,210)},iio.Color.lightgray=function(){return new iio.Color(211,211,211)},iio.Color.lightgreen=function(){return new iio.Color(144,238,144)},iio.Color.lightgrey=function(){return new iio.Color(211,211,211)},iio.Color.lightpink=function(){return new iio.Color(255,182,193)},iio.Color.lightsalmon=function(){return new iio.Color(255,160,122)},iio.Color.lightseagreen=function(){return new iio.Color(32,178,170)},iio.Color.lightskyblue=function(){return new iio.Color(135,206,250)},iio.Color.lightslategray=function(){return new iio.Color(119,136,153)},iio.Color.lightslategrey=function(){return new iio.Color(119,136,153)},iio.Color.lightsteelblue=function(){return new iio.Color(176,196,222)},iio.Color.lightyellow=function(){return new iio.Color(255,255,224)},iio.Color.lime=function(){return new iio.Color(0,255,0)},iio.Color.limegreen=function(){return new iio.Color(50,205,50)},iio.Color.linen=function(){return new iio.Color(250,240,230)},iio.Color.magenta=function(){return new iio.Color(255,0,255)},iio.Color.maroon=function(){return new iio.Color(128,0,0)},iio.Color.mediumaquamarine=function(){return new iio.Color(102,205,170)},iio.Color.mediumblue=function(){return new iio.Color(0,0,205)},iio.Color.mediumorchid=function(){return new iio.Color(186,85,211)},iio.Color.mediumpurple=function(){return new iio.Color(147,112,219)},iio.Color.mediumseagreen=function(){return new iio.Color(60,179,113)},iio.Color.mediumslateblue=function(){return new iio.Color(123,104,238)},iio.Color.mediumspringgreen=function(){return new iio.Color(0,250,154)},iio.Color.mediumturquoise=function(){return new iio.Color(72,209,204)},iio.Color.mediumvioletred=function(){return new iio.Color(199,21,133)},iio.Color.midnightblue=function(){return new iio.Color(25,25,112)},iio.Color.mintcream=function(){return new iio.Color(245,255,250)},iio.Color.mistyrose=function(){return new iio.Color(255,228,225)},iio.Color.moccasin=function(){return new iio.Color(255,228,181)},iio.Color.navajowhite=function(){return new iio.Color(255,222,173)},iio.Color.navy=function(){return new iio.Color(0,0,128)},iio.Color.oldlace=function(){return new iio.Color(253,245,230)},iio.Color.olive=function(){return new iio.Color(128,128,0)},iio.Color.olivedrab=function(){return new iio.Color(107,142,35)},iio.Color.orange=function(){return new iio.Color(255,165,0)},iio.Color.orangered=function(){return new iio.Color(255,69,0)},iio.Color.orchid=function(){return new iio.Color(218,112,214)},iio.Color.palegoldenrod=function(){return new iio.Color(238,232,170)},iio.Color.palegreen=function(){return new iio.Color(152,251,152)},iio.Color.paleturquoise=function(){return new iio.Color(175,238,238)},iio.Color.palevioletred=function(){return new iio.Color(219,112,147)},iio.Color.papayawhip=function(){return new iio.Color(255,239,213)},iio.Color.peachpuff=function(){return new iio.Color(255,218,185)},iio.Color.peru=function(){return new iio.Color(205,133,63)},iio.Color.pink=function(){return new iio.Color(255,192,203)},iio.Color.plum=function(){return new iio.Color(221,160,221)};iio.Color.powderblue=function(){return new iio.Color(176,224,230)},iio.Color.purple=function(){return new iio.Color(128,0,128)},iio.Color.rebeccapurple=function(){return new iio.Color(102,51,153)},iio.Color.red=function(){return new iio.Color(255,0,0)},iio.Color.rosybrown=function(){return new iio.Color(188,143,143)},iio.Color.royalblue=function(){return new iio.Color(65,105,225)},iio.Color.saddlebrown=function(){return new iio.Color(139,69,19)},iio.Color.salmon=function(){return new iio.Color(250,128,114)},iio.Color.sandybrown=function(){return new iio.Color(244,164,96)},iio.Color.seagreen=function(){return new iio.Color(46,139,87)},iio.Color.seashell=function(){return new iio.Color(255,245,238)},iio.Color.sienna=function(){return new iio.Color(160,82,45)},iio.Color.silver=function(){return new iio.Color(192,192,192)},iio.Color.skyblue=function(){return new iio.Color(135,206,235)},iio.Color.slateblue=function(){return new iio.Color(106,90,205)},iio.Color.slategray=function(){return new iio.Color(112,128,144)},iio.Color.slategrey=function(){return new iio.Color(112,128,144)},iio.Color.snow=function(){return new iio.Color(255,250,250)},iio.Color.springgreen=function(){return new iio.Color(0,255,127)},iio.Color.steelblue=function(){return new iio.Color(70,130,180)},iio.Color.tan=function(){return new iio.Color(210,180,140)},iio.Color.teal=function(){return new iio.Color(0,128,128)},iio.Color.thistle=function(){return new iio.Color(216,191,216)},iio.Color.tomato=function(){return new iio.Color(255,99,71)},iio.Color.turquoise=function(){return new iio.Color(64,224,208)},iio.Color.violet=function(){return new iio.Color(238,130,238)},iio.Color.wheat=function(){return new iio.Color(245,222,179)},iio.Color.white=function(){return new iio.Color(255,255,255)},iio.Color.whitesmoke=function(){return new iio.Color(245,245,245)},iio.Color.yellow=function(){return new iio.Color(255,255,0)},iio.Color.yellowgreen=function(){return new iio.Color(154,205,50)},iio.Gradient=function(){this.Gradient.apply(this,arguments)},iio.inherit(iio.Gradient,iio.Interface),iio.Gradient.prototype._super=iio.Interface.prototype,iio.Gradient.prototype.Gradient=function(){this._super.Interface.call(this,iio.merge_args(arguments))},iio.Gradient.prototype.convert_props=function(){iio.convert.property.vector(this,"start"),iio.convert.property.vector(this,"end");for(var a=0;a<this.stops.length;a++)iio.is.string(this.stops[a][1])&&(this.stops[a][1]=iio.convert.color(this.stops[a][1]))},iio.Gradient.prototype.canvasGradient=function(a){var b;b=this.startRadius?a.createRadialGradient(this.start.x,this.start.y,this.startRadius,this.end.x,this.end.y,this.endRadius):a.createLinearGradient(this.start.x,this.start.y,this.end.x,this.end.y);for(var c=0;c<this.stops.length;c++)b.addColorStop(this.stops[c][0],this.stops[c][1].rgbaString());return b},iio.Drawable=function(){this.Drawable.apply(this,arguments)},iio.inherit(iio.Drawable,iio.Interface),iio.Drawable.prototype._super=iio.Interface.prototype,iio.Drawable.prototype.Drawable=function(){iio.Drawable.prototype._super.Interface.call(this,arguments[0]),this.pos=this.pos||new iio.Vector(0,0),this.objs=[],this.collisions=[],this.loops=[]},iio.Drawable.prototype.set=function(){return iio.Drawable.prototype._super.set.call(this,arguments[0]),!0===arguments[arguments.length-1]||this.app&&this.app.draw(),this},iio.Drawable.prototype.convert_props=function(){iio.convert.property.color(this,"color"),iio.convert.property.color(this,"outline")},iio.Drawable.prototype.localFrameVector=function(a){return new iio.Vector(a.x-this.pos.x,a.y-this.pos.y)},iio.Drawable.prototype.localizeRotation=function(a,b){return this.rotation&&(this.origin&&(a.x-=this.origin.x,a.y-=this.origin.y),a.rotate(b?this.rotation:-this.rotation),this.origin&&(a.x+=this.origin.x,a.y+=this.origin.y)),a},iio.Drawable.prototype.localize=function(a,b){var a=new iio.Vector(a.x||a,a.y||b);return this.pos&&(a.x-=this.pos.x,a.y-=this.pos.y),this.localizeRotation(a)},iio.Drawable.prototype.localLeft=function(){return this.left()-this.pos.x},iio.Drawable.prototype.localRight=function(){return this.right()-this.pos.x},iio.Drawable.prototype.localTop=function(){return this.top()-this.pos.y},iio.Drawable.prototype.localBottom=function(){return this.bottom()-this.pos.y},iio.Drawable.prototype.clear=function(a){for(var b=0;b<this.objs.length;b++)iio.cancelLoops(this.objs[b]);return this.objs=[],a||this.app&&this.app.draw(),this},iio.Drawable.prototype.add=function(){if(arguments[0]instanceof Array)for(var a=0;a<arguments[0].length;a++)this.add(arguments[0][a],!0);else{if(arguments[0].parent=this,arguments[0].app=this.app,arguments[0].ctx=this.ctx,arguments[0].objs&&arguments[0].objs.length>0)for(var a=0;a<arguments[0].objs.length;a++)arguments[0].objs[a].app=this.app,arguments[0].objs[a].ctx=this.ctx;arguments[0]instanceof iio.Text&&(arguments[0].inferSize(),arguments[0].showCursor&&arguments[0].init_cursor()),void 0===arguments[0].z&&(arguments[0].z=0);for(var a=0;a<this.objs.length&&void 0!==this.objs[a].z&&arguments[0].z>=this.objs[a].z;)a++;this.objs.splice(a,0,arguments[0]),arguments[0].app&&(arguments[0].vel||arguments[0].vels||arguments[0].rVel||arguments[0].bezierVels||arguments[0].bezierAccs||arguments[0].acc||arguments[0].accs||arguments[0].rAcc||arguments[0].onUpdate||arguments[0].shrink||arguments[0].fade)&&!arguments[0].app.looping&&arguments[0].app.loop()}return!0===arguments[arguments.length-1]||this.app&&this.app.draw(),arguments[0]},iio.Drawable.prototype.rmv=function(){if(!this.objs)return!1;if(arguments[0]instanceof Array)for(var a=0;a<arguments[0].length;a++)this.rmv(arguments[0][a],!0);else{var b=arguments[0];if(remove=function(a,c,d){return a==b&&(d.splice(c,1),!0)},iio.is.number(arguments[0])){if(!(arguments[0]<this.objs.length))return!1;b=this.objs.splice(arguments[0],1)}else this.objs&&this.objs.some(remove);this.collisions&&this.collisions.forEach(function(a,c){a[0]===b||a[1]===b?this.collisions.splice(c,1):(a[0]instanceof Array&&a[0].some(remove),a[1]instanceof Array&&a[1].some(remove))})}return!0===arguments[arguments.length-1]||this.app&&this.app.draw(),arguments[0]},iio.Drawable.prototype.create=function(){for(var a={},b=0;b<arguments.length;b++)null!==arguments[b]&&(iio.is.string(arguments[b])?iio.Color[arguments[b]]?a.color=iio.Color[arguments[b]]():a.text=arguments[b]:arguments[b]instanceof iio.Color?a.color=arguments[b]:arguments[b]instanceof iio.Vector?a.pos=arguments[b]:arguments[b]instanceof Array?a.pos=iio.convert.vector(arguments[b]):"object"==typeof arguments[b]?a=iio.merge(a,arguments[b]):iio.is.number(arguments[b])&&(a.width=arguments[b]));return a.vs?2===a.vs.length?this.add(new iio.Line(a)):this.add(new iio.Polygon(a)):a.radius?this.add(new iio.Ellipse(a)):a.text?this.add(new iio.Text(a)):a.res||a.R||a.C?this.add(new iio.Grid(a)):a.width?this.add(new iio.Quad(a)):a.color?a.color:!!a.pos&&a.pos},iio.Drawable.prototype.collision=function(a,b,c){return this.collisions.push([a,b,c]),this.collisions.length-1},iio.Drawable.prototype.cCollisions=function(a,b,c){if(a instanceof Array)if(b instanceof Array){if(0==b.length)return;a.forEach(function(a){b.forEach(function(b){iio.collision.check(a,b)&&c(a,b)})})}else a.forEach(function(a){iio.collision.check(a,b)&&c(a,b)});else b instanceof Array?b.forEach(function(b){iio.collision.check(a,b)&&c(a,b)}):iio.collision.check(a,b)&&c(a,b)},iio.Drawable.prototype._update=function(a,b){var c;return this.objs&&0===this.objs.length&&(c=!1),this.update&&(result=this.update(b),"undefined"!=typeof result&&(c=result)),this.collisions&&this.collisions.length>0&&this.collisions.forEach(function(a){this.cCollisions(a[0],a[1],a[2])},this),this.objs&&this.objs.length>0&&this.objs.forEach(function(c){c.update&&c.update(a,b)&&this.rmv(c)},this),c},iio.Drawable.prototype.loop=function(a,b){this.looping=!0;var c;return void 0===b?void 0===a?(this.app.mainLoop&&iio.cancelLoop(this.app.mainLoop.id),c=this.app.mainLoop={fps:60,fn:this,af:this.rqAnimFrame,o:this.app},this.app.fps=c.fps,c.id=this.app.mainLoop.id=iio.loop(this.app.mainLoop)):iio.is.number(a)?(this.app.mainLoop&&iio.cancelLoop(this.app.mainLoop.id),c=this.app.mainLoop={fps:a,o:this.app,af:!1},this.app.fps=a,c.id=this.app.mainLoop.id=iio.loop(this.app.mainLoop)):(c={fps:60,fn:a,af:this.rqAnimFrame},c.id=iio.loop(c,a)):(c={fps:a,fn:b,o:this,af:this.rqAnimFrame},c.id=iio.loop(a,c)),this.loops.push(c),c.id},iio.Drawable.prototype.togglePause=function(a){this.paused?this.unpause(a):this.pause(a)},iio.Drawable.prototype.pause=function(a){return this.paused||(iio.cancelLoops(this),iio.cancelLoop(this.mainLoop.id),this.paused=!0),this},iio.Drawable.prototype.unpause=function(a){if(this.paused){this.paused=!1;var b=this;this.loops.forEach(function(a){b.mainLoop&&a.id===b.mainLoop.id?iio.loop(b.mainLoop):iio.loop(a)}),void 0===a&&this.objs.forEach(function(a){a.loops.forEach(function(a){iio.loop(a)})})}},iio.SpriteMap=function(){this.SpriteMap.apply(this,arguments)},iio.SpriteMap.prototype.SpriteMap=function(a,b){return this.img=new Image,this.img.src=a,this.img.onload=b,this},iio.SpriteMap.prototype.sprite=function(){var a=iio.merge_args(arguments),b={};if(b.name=a.name,b.numFrames=a.numFrames||1,a.origin=iio.convert.vector(a.origin),a.frames)b.frames=a.frames;else{b.frames=[];for(var c=0;c<b.numFrames;c++)b.frames[c]={x:a.origin.x+a.width*c,y:a.origin.y,w:a.width,h:a.height}}return b.frames.forEach(function(b){b.src||(b.src=this.img),b.w||(b.w=a.width),b.h||(b.h=a.height)},this),b},iio.Shape=function(){this.Shape.apply(this,arguments)},iio.inherit(iio.Shape,iio.Drawable),iio.Shape.prototype._super=iio.Drawable.prototype,iio.Shape.prototype.Shape=function(){iio.Shape.prototype._super.Drawable.call(this,arguments[0])},iio.Shape.prototype.convert_props=function(){if(iio.Shape.prototype._super.convert_props.call(this,iio.merge_args(arguments)),iio.convert.property.color(this,"outline"),iio.convert.property.color(this,"shadow"),!this.dash||this.dash instanceof Array||(this.dash=[this.dash]),iio.convert.property.vector(this,"pos"),iio.convert.property.vector(this,"origin"),iio.convert.property.vector(this,"vel"),iio.convert.property.vector(this,"acc"),iio.convert.property.vector(this,"shadowOffset"),iio.convert.property.vector(this,"res"),iio.convert.property.vectors(this,"vs"),iio.convert.property.vectors(this,"vels"),iio.convert.property.vectors(this,"accs"),iio.convert.property.vectors(this,"bezier"),iio.convert.property.vectors(this,"bezierVels"),iio.convert.property.vectors(this,"bezierAccs"),void 0!==this.fade&&void 0===this.alpha&&(this.alpha=1),void 0===this.rAcc||this.rVel||(this.rVel=0),void 0===this.rVel||this.rotation||(this.rotation=0),this.accs&&!this.vels){this.vels=[];for(var a=0;a<this.accs.length;a++)this.vels.push(new iio.Vector)}if(this.bezierAccs&&!this.bezierVels){this.bezierVels=[];for(var a=0;a<this.bezierAccs.length;a++)this.bezierVels.push(new iio.Vector)}if(this.bezierVels&&!this.bezier){this.bezier=[];for(var a=0;a<this.bezierVels.length;a++)this.bezier.push(new iio.Vector)}if(this.img)if(iio.is.string(this.img)){var b=this.img;this.img=new Image,this.img.src=b,this.img.parent=this;var c=this;this.size()?this.img.onload=function(a){c.app&&c.app.draw()}:this.img.onload=function(a){c.setSize(c.img.width||0,c.img.height||0),c.app&&c.app.draw()}}else this.size()||(this.setSize(this.img.width||0,this.img.height||0),this.app&&this.app.draw());this.anims&&(this.animFrame=this.animFrame||0)},iio.Shape.prototype.left=function(){return this.pos?this.pos.x:0},iio.Shape.prototype.right=function(){return this.pos?this.pos.x:0},iio.Shape.prototype.top=function(){return this.pos?this.pos.y:0},iio.Shape.prototype.bottom=function(){return this.pos?this.pos.y:0},iio.Shape.prototype.resolve=function(a,b){return!a.callback||a.callback(b)},iio.Shape.prototype.over_upper_limit=function(a,b,c){return!!(iio.is.number(a)&&b>a||void 0!==a.bound&&b>a.bound)&&this.resolve(a,c)},iio.Shape.prototype.below_lower_limit=function(a,b,c){return!!(iio.is.number(a)&&b<a||void 0!==a.bound&&b<a.bound)&&this.resolve(a,c)},iio.Shape.prototype.update=function(){var a=!1;if(this.bounds&&(a=this.past_bounds()),this.shrink&&(a=this.update_shrink()),this.fade&&(a=this.update_fade()),a)return a;this.acc&&this.update_acc(),this.vel&&this.update_vel(),this.rAcc&&(this.rVel+=this.rAcc),this.rVel&&this.update_rotation(),this.accs&&this.update_accs(),this.vels&&this.vs&&this.update_vels(),this.bezierAccs&&this.update_bezier_accs(),this.bezierVels&&this.update_bezier_vels(),this.onUpdate&&this.onUpdate(this)},iio.Shape.prototype.update_vel=function(){if(this.pos)this.vel.x&&(this.pos.x+=this.vel.x),this.vel.y&&(this.pos.y+=this.vel.y);else if(this.vs)for(var a=0;a<this.vs.length;a++)this.vel.x&&(this.vs[a].x+=this.vel.x),this.vel.y&&(this.vs[a].y+=this.vel.y)},iio.Shape.prototype.update_vels=function(){for(var a=0;a<this.vels.length;a++)this.vels[a].x&&(this.vs[a].x+=this.vels[a].x),this.vels[a].y&&(this.vs[a].y+=this.vels[a].y)},iio.Shape.prototype.update_bezier_vels=function(){for(var a=0;a<this.bezierVels.length;a++)this.bezierVels[a].x&&(this.bezier[a].x+=this.bezierVels[a].x),this.bezierVels[a].y&&(this.bezier[a].y+=this.bezierVels[a].y)},iio.Shape.prototype.update_bezier_accs=function(){for(var a=0;a<this.bezierAccs.length;a++)this.bezierAccs[a].x&&(this.bezierVels[a].x+=this.bezierAccs[a].x),this.bezierAccs[a].y&&(this.bezierVels[a].y+=this.bezierAccs[a].y)},iio.Shape.prototype.update_rotation=function(){this.rotation+=this.rVel,(this.rotation>6283||this.rotation<-6283)&&(this.rotation=0)},iio.Shape.prototype.update_acc=function(){this.vel.x+=this.acc.x,this.vel.y+=this.acc.y},iio.Shape.prototype.update_accs=function(){for(var a=0;a<this.accs.length;a++)this.accs[a].x&&(this.vels[a].x+=this.accs[a].x),this.accs[a].y&&(this.vels[a].y+=this.accs[a].y)},iio.Shape.prototype.update_shrink=function(){return this.shrink.speed?this._shrink(this.shrink.speed,this.shrink.callback):this._shrink(this.shrink)},iio.Shape.prototype.update_fade=function(){return this.fade.speed?this._fade(this.fade.speed,this.fade.callback):this._fade(this.fade)},iio.Shape.prototype.past_bounds=function(){return!(!this.bounds.right||!this.over_upper_limit(this.bounds.right,this.right(),this))||(!(!this.bounds.left||!this.below_lower_limit(this.bounds.left,this.left(),this))||(!(!this.bounds.top||!this.below_lower_limit(this.bounds.top,this.top(),this))||(!(!this.bounds.bottom||!this.over_upper_limit(this.bounds.bottom,this.bottom(),this))||(!(!this.bounds.rightRotation||!this.over_upper_limit(this.bounds.rightRotation,this.rotation,this))||!(!this.bounds.leftRotation||!this.below_lower_limit(this.bounds.leftRotation,this.rotation,this))))))},iio.Shape.prototype.playAnim=function(){var a=iio.merge_args(arguments);a.name&&this.setSprite(a.name),this.animFrame=a.startFrame||0,this.animRepeats=a.repeat,this.onAnimComplete=a.onAnimComplete;return a.fps>0?this.loop(a.fps,this.nextFrame):a.fps<0?this.loop(-1*a.fps,this.prevFrame):this.app.draw(),this},iio.Shape.prototype.stopAnim=function(){return iio.cancelLoops(this),this},iio.Shape.prototype.setSprite=function(a,b){if(iio.cancelLoops(this),iio.is.string(a)){var c=this;this.anims.some(function(b,d){return b.name===a&&(c.animFrame=0,c.animKey=d,c.width=b.frames[c.animFrame].w,c.height=b.frames[c.animFrame].h,!0)})}else this.anims.splice(0,0,a),this.animKey=0,this.animFrame=0,this.width=a.frames[0].w,this.height=a.frames[0].h;return b||c.app.draw(),this},iio.Shape.prototype.nextFrame=function(a){if(++a.animFrame>=a.anims[a.animKey].frames.length&&(a.animFrame=0,void 0!==a.animRepeats)){if(a.animRepeats<=1)return window.cancelAnimationFrame(id),window.clearTimeout(id),void(a.onAnimComplete&&a.onAnimComplete(a));a.animRepeats--}},iio.Shape.prototype.prevFrame=function(a){a.animFrame--,a.animFrame<0&&(a.animFrame=a.anims[a.animKey].frames.length-1),a.app.draw()},iio.Shape.prototype._shrink=function(a,b){if(this.width*=1-a,this.height*=1-a,this.width<.02||this.width<this.shrink.lowerBound||this.width>this.shrink.upperBound)return!b||b(this)},iio.Shape.prototype._fade=function(a,b){if(this.alpha*=1-a,this.alpha<a||this.alpha>1-a||this.alpha>this.fade.upperBound||this.alpha<this.fade.lowerBound)return this.alpha>1?this.alpha=1:this.alpha<0&&(this.alpha=0),!b||b(this)},iio.Shape.prototype.orient_ctx=function(a){return a=a||this.app.ctx,a.save(),this.pos&&(this.imageRounding?a.translate(Math.floor(this.pos.x),Math.floor(this.pos.y)):a.translate(this.pos.x,this.pos.y)),this.rotation&&(this.origin&&(this.imageRounding?a.translate(Math.floor(this.origin.x),Math.floor(this.origin.y)):a.translate(this.origin.x,this.origin.y)),a.rotate(this.rotation),this.origin&&(this.imageRounding?a.translate(Math.floor(-this.origin.x),Math.floor(-this.origin.y)):a.translate(-this.origin.x,-this.origin.y))),this.flip&&(this.flip.indexOf("x")>-1&&a.scale(-1,1),this.flip.indexOf("y")>-1&&a.scale(1,-1)),a},iio.Shape.prototype.prep_ctx_color=function(a){return this.color instanceof iio.Gradient?a.fillStyle=this.color.canvasGradient(a):a.fillStyle=this.color.rgbaString(),a},iio.Shape.prototype.prep_ctx_outline=function(a){return this.outline instanceof iio.Gradient?a.strokeStyle=this.outline.canvasGradient(a):a.strokeStyle=this.outline.rgbaString(),a},iio.Shape.prototype.prep_ctx_lineWidth=function(a){return a.lineWidth=this.lineWidth||1,a},iio.Shape.prototype.prep_ctx_shadow=function(a){return a.shadowColor=this.shadow.rgbaString(),this.shadowBlur&&(a.shadowBlur=this.shadowBlur),this.shadowOffset?(a.shadowOffsetX=this.shadowOffset.x,a.shadowOffsetY=this.shadowOffset.y):(a.shadowOffsetX=5,a.shadowOffsetY=5),a},iio.Shape.prototype.prep_ctx_dash=function(a){return this.dashOffset&&(a.lineDashOffset=this.dashOffset),a.setLineDash(this.dash),a},iio.Shape.prototype.finish_path_shape=function(a){this.color&&a.fill(),this.img&&(this.imageRounding?a.drawImage(this.img,Math.floor(-this.width/2),Math.floor(-this.height/2),Math.floor(this.width),Math.floor(this.height)):a.drawImage(this.img,-this.width/2,-this.height/2,this.width,this.height)),this.anims&&(this.imageRounding?a.drawImage(this.anims[this.animKey].frames[this.animFrame].src,this.anims[this.animKey].frames[this.animFrame].x,this.anims[this.animKey].frames[this.animFrame].y,this.anims[this.animKey].frames[this.animFrame].w,this.anims[this.animKey].frames[this.animFrame].h,Math.floor(-this.width/2),Math.floor(-this.height/2),Math.floor(this.width),Math.floor(this.height)):a.drawImage(this.anims[this.animKey].frames[this.animFrame].src,this.anims[this.animKey].frames[this.animFrame].x,this.anims[this.animKey].frames[this.animFrame].y,this.anims[this.animKey].frames[this.animFrame].w,this.anims[this.animKey].frames[this.animFrame].h,-this.width/2,-this.height/2,this.width,this.height)),this.outline&&a.stroke(),this.clip&&a.clip()},iio.Shape.prototype.draw_obj=function(a){a.save(),this.alpha&&(a.globalAlpha=this.alpha),this.lineCap&&(a.lineCap=this.lineCap),this.shadow&&(a=this.prep_ctx_shadow(a)),this.dash&&(a=this.prep_ctx_dash(a)),this.color&&(a=this.prep_ctx_color(a)),this.outline&&(a=this.prep_ctx_outline(a),a=this.prep_ctx_lineWidth(a)),!this.img&&!this.anims||this.noImageSmoothing||(a.mozImageSmoothingEnabled=!1,a.imageSmoothingEnabled=!1),this.draw_shape&&this.draw_shape(a),a.restore()},iio.Shape.prototype.draw=function(a){if(!this.hidden){if(a=this.orient_ctx(a),this.objs&&this.objs.length>0){for(var b=!1,c=0;c<this.objs.length;c++)!b&&this.objs[c].z>=this.z&&(this.draw_obj(a),b=!0),this.objs[c].draw&&(!this.clipObjs||this.objs[c].right()>this.localLeft()&&this.objs[c].left()<this.localRight()&&this.objs[c].bottom()>this.localTop()&&this.objs[c].top()<this.localBottom())&&this.objs[c].draw(a);b||this.draw_obj(a)}else this.draw_obj(a);a.restore()}},iio.Ellipse=function(){this.Ellipse.apply(this,arguments)},iio.inherit(iio.Ellipse,iio.Shape),iio.Ellipse.prototype._super=iio.Shape.prototype,iio.Ellipse.prototype.Ellipse=function(){this._super.Shape.call(this,iio.merge_args(arguments))},iio.Ellipse.prototype.left=function(){return this.pos.x-this.radius},iio.Ellipse.prototype.right=function(){return this.pos.x+this.radius},iio.Ellipse.prototype.top=function(){return this.pos.y-(this.vRadius||this.radius)},iio.Ellipse.prototype.bottom=function(){return this.pos.y+(this.vRadius||this.radius)},iio.Ellipse.prototype._shrink=function(a,b){if(this.radius*=1-a,this.vRadius&&(this.vRadius*=1-a),this.radius<.02||this.radius<this.shrink.lowerBound||this.radius>this.shrink.upperBound)return!b||b(this)},iio.Ellipse.prototype.size=function(){return this.radius},iio.Ellipse.prototype.setSize=function(a,b){return this.radius=a/2,this.vRadius=b?b/2:void 0,this},iio.Ellipse.prototype.contains=function(a,b){return void 0!==b&&(a={x:a,y:b}),(!this.vRadius||this.radius===this.vRadius)&&iio.Vector.dist(a,this.pos)<this.radius||(a=this.localize(a),Math.pow(a.x,2)/Math.pow(this.radius,2)+Math.pow(a.y,2)/Math.pow(this.vRadius,2)<=1)},iio.Ellipse.prototype.draw_shape=function(a){a.beginPath(),void 0!==this.vRadius?a.ellipse?a.ellipse(0,0,this.radius,this.vRadius,0,0,2*Math.PI,!1):(a.save(),a.translate(-this.radius,-this.vRadius),a.scale(this.radius,this.vRadius),a.arc(1,1,1,0,2*Math.PI,!1),a.restore()):a.arc(0,0,this.radius,0,2*Math.PI,!1),this.color&&a.fill(),this.outline&&a.stroke(),this.clip&&a.clip(),this.img&&(this.imageRounding?a.drawImage(this.img,Math.floor(-this.radius),Math.floor(-(this.vRadius||this.radius)),Math.floor(2*this.radius),Math.floor(2*(this.vRadius||this.radius))):a.drawImage(this.img,-this.radius,-(this.vRadius||this.radius),2*this.radius,2*(this.vRadius||this.radius))),this.refLine&&(a.save(),a.lineWidth=this.refLineWidth||this.lineWidth||1,this.refLine instanceof iio.Color?a.strokeStyle=this.refLine.rgbaString():this.color?a.strokeStyle=this.color.rgbaString():a.strokeStyle=this.outline.rgbaString(),a.beginPath(),a.moveTo(0,0),a.lineTo(0,this.radius),a.stroke(),a.restore())},iio.Polygon=function(){this.Polygon.apply(this,arguments)},iio.inherit(iio.Polygon,iio.Shape),iio.Polygon.prototype._super=iio.Shape.prototype,iio.Polygon.prototype.Polygon=function(){this._super.Shape.call(this,iio.merge_args(arguments))},iio.Polygon.prototype.left=function(){return iio.Vector.leftmost(this.trueVs())},iio.Polygon.prototype.right=function(){return iio.Vector.rightmost(this.trueVs())},iio.Polygon.prototype.top=function(){return iio.Vector.highest(this.trueVs())},iio.Polygon.prototype.bottom=function(){return iio.Vector.lowest(this.trueVs())},iio.Polygon.prototype.finish_path_shape=function(a){if(this.color&&a.fill(),this.img){var b=iio.Vector.leftmost(this.vs),c=iio.Vector.highest(this.vs),d=iio.Vector.rightmost(this.vs),e=iio.Vector.lowest(this.vs);this.imageRounding&&(b=Math.floor(b),d=Math.floor(d),c=Math.floor(c),e=Math.floor(e)),a.drawImage(this.img,b,c,d-b,e-c)}this.outline&&a.stroke(),this.clip&&a.clip()},iio.Polygon.prototype.trueVs=function(){for(var a,b=[],c=0;c<this.vs.length;c++)a=this.localizeRotation(this.vs[c].clone(),!0),a.x+=this.pos.x,a.y+=this.pos.y,b[c]=a;return b},iio.Polygon.prototype.contains=function(a,b){a=this.localize(a,b);var d=j=c=0;for(d=0,j=this.vs.length-1;d<this.vs.length;j=d++)this.vs[d].y>a.y!=this.vs[j].y>a.y&&a.x<(this.vs[j].x-this.vs[d].x)*(a.y-this.vs[d].y)/(this.vs[j].y-this.vs[d].y)+this.vs[d].x&&(c=!c);return c},iio.Polygon.prototype.draw_shape=function(a){if(a.beginPath(),a.moveTo(this.vs[0].x,this.vs[0].y),this.bezier){for(var b=0,c=1;c<this.vs.length;c++)a.this.bezierCurveTo(this.bezier[b++]||this.vs[c-1].x,this.bezier[b++]||this.vs[c-1].y,this.bezier[b++]||this.vs[c].x,this.bezier[b++]||this.vs[c].y,this.vs[c].x,this.vs[c].y);this.open||(c--,a.this.bezierCurveTo(this.bezier[b++]||this.vs[c].x,this.bezier[b++]||this.vs[c].y,this.bezier[b++]||0,this.bezier[b++]||0,0,0))}else for(var c=1;c<this.vs.length;c++)a.lineTo(this.vs[c].x,this.vs[c].y);this.open||a.closePath(),this.finish_path_shape(a)},iio.Line=function(){this.Line.apply(this,arguments)},iio.inherit(iio.Line,iio.Shape),iio.Line.prototype._super=iio.Shape.prototype,iio.Line.prototype.Line=function(){this._super.Shape.call(this,iio.merge_args(arguments))},iio.Line.prototype.trueVs=iio.Polygon.prototype.trueVs,iio.Line.prototype.left=iio.Polygon.prototype.left,iio.Line.prototype.right=iio.Polygon.prototype.right,iio.Line.prototype.top=iio.Polygon.prototype.top,iio.Line.prototype.bottom=iio.Polygon.prototype.bottom,iio.Line.prototype.prep_ctx_color=function(a){return this.color instanceof iio.Gradient?a.strokeStyle=this.color.canvasGradient(a):a.strokeStyle=this.color.rgbaString(),a=this.prep_ctx_lineWidth(a)},iio.Line.prototype.prep_ctx_lineWidth=function(a){return a.lineWidth=this.width||1,a},iio.Line.prototype.draw_shape=function(a){a.beginPath(),a.moveTo(this.vs[0].x,this.vs[0].y),this.bezier?a.bezierCurveTo(this.bezier[0].x,this.bezier[0].y,this.bezier[1].x,this.bezier[1].y,this.vs[1].x,this.vs[1].y):a.lineTo(this.vs[1].x,this.vs[1].y),a.stroke()},iio.Rectangle=function(){this.Rectangle.apply(this,arguments)},iio.inherit(iio.Rectangle,iio.Polygon),iio.Rectangle.prototype._super=iio.Polygon.prototype,iio.Rectangle.prototype.Rectangle=function(){this._super.Polygon.call(this,iio.merge_args(arguments)),this.height=this.height||this.width,this.vs=[new iio.Vector(-this.width/2,-this.height/2),new iio.Vector(this.width/2,-this.height/2),new iio.Vector(this.width/2,this.height/2),new iio.Vector(-this.width/2,this.height/2)]},iio.Rectangle.prototype.size=function(){return this.width},iio.Rectangle.prototype.setSize=function(a,b){this.width=a,this.height=b||a},iio.Rectangle.prototype.contains=function(a,b){return a=this.localize(a,b),a.x>-this.width/2&&a.x<this.width/2&&a.y>-this.height/2&&a.y<this.height/2},iio.Rectangle.prototype.draw_shape=function(a){this.imageRounding?a.translate(Math.floor(-this.width/2),Math.floor(-this.height/2)):a.translate(-this.width/2,-this.height/2),this.round?this.draw_rounded(a):(this.color&&a.fillRect(0,0,this.width,this.height),this.img&&a.drawImage(this.img,0,0,this.width,this.height),this.anims&&a.drawImage(this.anims[this.animKey].frames[this.animFrame].src,this.anims[this.animKey].frames[this.animFrame].x,this.anims[this.animKey].frames[this.animFrame].y,this.anims[this.animKey].frames[this.animFrame].w,this.anims[this.animKey].frames[this.animFrame].h,0,0,this.width,this.height),this.outline&&a.strokeRect(0,0,this.width,this.height))},iio.Rectangle.prototype.draw_rounded=function(a){a.beginPath(),a.moveTo(this.round[0],0),a.lineTo(this.width-this.round[1],0),a.quadraticCurveTo(this.width,0,this.width,this.round[1]),a.lineTo(this.width,this.height-this.round[2]),a.quadraticCurveTo(this.width,this.height,this.width-this.round[2],this.height),a.lineTo(this.round[3],this.height),a.quadraticCurveTo(0,this.height,0,this.height-this.round[3]),a.lineTo(0,this.round[0]),a.quadraticCurveTo(0,0,this.round[0],0),a.closePath(),a.stroke(),a.fill(),a.clip()},iio.Quad=function(){this.Quad.apply(this,arguments)},iio.inherit(iio.Quad,iio.Shape),iio.Quad.prototype._super=iio.Shape.prototype,iio.Quad.prototype.Quad=function(){this._super.Shape.call(this,iio.merge_args(arguments)),this.height=this.height||this.width},iio.Quad.prototype.draw_shape=iio.Rectangle.prototype.draw_shape,iio.Quad.prototype.draw_rounded=iio.Rectangle.prototype.draw_rounded,iio.Quad.prototype.contains=iio.Rectangle.prototype.contains,iio.Quad.prototype.size=iio.Rectangle.prototype.size,iio.Quad.prototype.setSize=iio.Rectangle.prototype.setSize,iio.Quad.prototype._trueVs=iio.Polygon.prototype.trueVs,iio.Quad.prototype._left=iio.Polygon.prototype.left,iio.Quad.prototype.left=function(){return this.rotateVs?this._left():this.pos.x-this.width/2},iio.Quad.prototype._right=iio.Polygon.prototype.right,iio.Quad.prototype.right=function(){return this.rotateVs?this._right():this.pos.x+this.width/2},iio.Quad.prototype._top=iio.Polygon.prototype.top,iio.Quad.prototype.top=function(){return this.rotateVs?this._top():this.pos.y-this.height/2},iio.Quad.prototype._bottom=iio.Polygon.prototype.bottom,iio.Quad.prototype.bottom=function(){return this.rotateVs?this._bottom():this.pos.y+this.height/2},iio.Quad.prototype.trueVs=function(a){if(this.vs=[new iio.Vector(-this.width/2,-this.height/2),new iio.Vector(this.width/2,-this.height/2),new iio.Vector(this.width/2,this.height/2),new iio.Vector(-this.width/2,this.height/2)],!a&&!this.rotateVs){for(var b,c=[],d=0;d<this.vs.length;d++)b=this.vs[d].clone(),b.x+=this.pos.x,b.y+=this.pos.y,c[d]=b;return c}return this._trueVs()},iio.Text=function(){this.Text.apply(this,arguments)},iio.inherit(iio.Text,iio.Polygon),iio.Text.prototype._super=iio.Polygon.prototype,iio.Text.prototype.Text=function(){this._super.Polygon.call(this,iio.merge_args(arguments)),this.size=this.size||40,this.outline||(this.color=this.color||new iio.Color),this.font=this.font||"Arial",this.align=this.align||"center"},iio.Text.prototype._shrink=function(a,b){if(this.size*=1-a,this.inferSize(),this.size<.02||this.size<this.shrink.lowerBound||this.size>this.shrink.upperBound)return!b||b(this)},iio.Text.prototype.contains=function(a,b){return a=this.localize(a,b),(!this.align||"left"===this.align)&&a.x>0&&a.x<this.width&&a.y<this.height/2&&a.y>-this.height/2||("center"===this.align&&a.x>-this.width/2&&a.x<this.width/2&&a.y<this.height/2&&a.y>-this.height/2||("right"===this.align||"end"===this.align)&&a.x>-this.width&&a.x<0&&a.y<this.height/2&&a.y>-this.height/2)},iio.Text.prototype.draw_shape=function(a){a.translate(0,this.height/2),a.font=this.size+"px "+this.font,a.textAlign=this.align,this.color&&a.fillText(this.text,0,0),this.outline&&a.strokeText(this.text,0,0),this.showCursor&&(this.cursor.vs[0].x=this.cursor.vs[1].x=this.charX(this.cursor.index))},iio.Text.prototype.init_cursor=function(){var a=this.charX(this.text.length);this.cursor=this.add(new iio.Line({vs:[[a,this.size/2],[a,-this.size/2]],width:2,color:this.color||this.outline,index:this.text.length,shift:!1})),this.showCursor?this.loop(2,function(a){a.cursor.hidden=!a.cursor.hidden}):this.cursor.hidden=!0},iio.Text.prototype.inferSize=function(a){return this.ctx=a||this.ctx,this.app.ctx.font=this.size+"px "+this.font,this.width=this.app.ctx.measureText(this.text).width,this.height=this.app.ctx.measureText("H").width,this.align&&"left"!==this.align?"center"===this.align?this.vs=[new iio.Vector(-this.width/2,-this.height/2),new iio.Vector(this.width/2,-this.height/2),new iio.Vector(this.width/2,this.height/2),new iio.Vector(-this.width/2,this.height/2)]:this.vs=[new iio.Vector(-this.width,-this.height/2),new iio.Vector(0,-this.height/2),new iio.Vector(0,this.height/2),new iio.Vector(-this.width,this.height/2)]:this.vs=[new iio.Vector(0,-this.height/2),new iio.Vector(this.width,-this.height/2),new iio.Vector(this.width,this.height/2),new iio.Vector(0,this.height/2)],this},iio.Text.getFontHeight=function(a){var b=$("<span>Hg</span>").css({fontFamily:a}),c=$('<div style="display: inline-block; width: 1px; height: 0px;"></div>'),d=$("<div></div>");d.append(b,c),$("body").append(d);try{var e={};c.css({verticalAlign:"baseline"}),e.ascent=c.offset().top-b.offset().top,c.css({verticalAlign:"bottom"}),e.height=c.offset().top-b.offset().top,e.descent=e.height-e.ascent}finally{d.remove()}return e},iio.Text.prototype.charWidth=function(a){return a=a||0,this.app.ctx.font=this.size+"px "+this.font,this.app.ctx.measureText(this.text.charAt(a)).width},iio.Text.prototype.charX=function(a){if(this.app.ctx.font=this.size+"px "+this.font,!this.align||"left"===this.align)return this.app.ctx.measureText(this.text.substring(0,a)).width;if("right"===this.align||"end"===this.align)return-this.app.ctx.measureText(this.text.substring(0,this.text.length-a)).width;if("center"===this.align){return-Math.floor(this.app.ctx.measureText(this.text).width/2)+this.app.ctx.measureText(this.text.substring(0,a)).width}},iio.Text.prototype.onKeyUp=function(a){"shift"===a&&(this.cursor.shift=!1)},iio.Text.prototype.onKeyDown=function(a,b,c,d){iio.is.number(b)||(d=b,b=this.cursor.index);var e,f=this.text.substring(0,b),g=this.text.substring(b);return void 0!==d&&!1!==(e=d(a,c,f,g))?(this.text=f+e+g,this.cursor.index=b+1,this.showCursor&&(this.cursor.hidden=!1),this.app.draw(),this.cursor.index):(a.length>1?"space"===a?(this.text=f+" "+g,b++):"backspace"===a&&b>0?(this.text=f.substring(0,f.length-1)+g,b--):"delete"===a&&b<this.text.length?this.text=f+g.substring(1):"left arrow"===a&&b>0?b--:"right arrow"===a&&b<this.text.length?b++:"shift"===a?this.cursor.shift=!0:"semi-colon"===a?(this.text=c?f+":"+g:f+";"+g,b++):"equal"===a?(this.text=c?f+"+"+g:f+"="+g,b++):"comma"===a?(this.text=c?f+"<"+g:f+","+g,b++):"dash"===a?(this.text=c?f+"_"+g:f+"-"+g,b++):"period"===a?(this.text=c?f+">"+g:f+"."+g,b++):"forward slash"===a?(this.text=c?f+"?"+g:f+"/"+g,b++):"grave accent"===a?(this.text=c?f+"~"+g:f+"`"+g,b++):"open bracket"===a?(this.text=c?f+"{"+g:f+"["+g,b++):"back slash"===a?(this.text=c?f+"|"+g:f+"/"+g,b++):"close bracket"===a?(this.text=c?f+"}"+g:f+"]"+g,b++):"single quote"===a&&(this.text=c?f+'"'+g:f+"'"+g,b++):(c||this.cursor.shift?this.text=f+a.charAt(0).toUpperCase()+g:this.text=f+a+g,b++),this.showCursor&&(this.cursor.hidden=!1),this.cursor.index=b,this.app.draw(),b)},iio.Grid=function(){this.Grid.apply(this,arguments)},iio.inherit(iio.Grid,iio.Quad),iio.Grid.prototype._super=iio.Quad.prototype,iio.Grid.prototype.Grid=function(){this._super.Quad.call(this,iio.merge_args(arguments)),this.init()},iio.Grid.prototype.prep_ctx_color=iio.Line.prototype.prep_ctx_color,iio.Grid.prototype.clear=function(a){this.objs=[],this.init_cells(),a||this.app.draw()},iio.Grid.prototype._shrink=function(a,b){if(this.setSize(this.width*(1-a),this.height*(1-a)),this.width<.02||this.width<this.shrink.lowerBound||this.width>this.shrink.upperBound)return!b||b(this)},iio.Grid.prototype.setSize=function(a,b){this.width=a,this.height=b||a,this.infer_res()},iio.Grid.prototype.draw_shape=function(a){if(this.color){a.beginPath();for(var b=1;b<this.C;b++)a.moveTo(-this.width/2+b*this.res.x,-this.height/2),a.lineTo(-this.width/2+b*this.res.x,this.height/2);for(var c=1;c<this.R;c++)a.moveTo(-this.width/2,-this.height/2+c*this.res.y),a.lineTo(this.width/2,-this.height/2+c*this.res.y);a.stroke()}},iio.Grid.prototype.init=function(){this.res=this.res||new iio.Vector(this.width/this.C,this.height/this.R),this.width=this.width||this.C*this.res.x,this.height=this.height||this.R*this.res.y,this.init_cells()},iio.Grid.prototype.init_cells=function(){this.cells=[];for(var a,b=-this.res.x*(this.C-1)/2,c=-this.res.y*(this.R-1)/2,d=0;d<this.C;d++){for(this.cells[d]=[],a=0;a<this.R;a++)this.cells[d][a]=this.add(new iio.Quad({pos:new iio.Vector(b,c),c:d,r:a,width:this.res.x,height:this.res.y})),c+=this.res.y;c=-this.res.y*(this.R-1)/2,b+=this.res.x}},iio.Grid.prototype.infer_res=function(){this.res.x=this.width/this.C,this.res.y=this.height/this.R},iio.Grid.prototype.cellCenter=function(a,b){return new iio.Vector(-this.width/2+a*this.res.x+this.res.x/2,-this.height/2+b*this.res.y+this.res.y/2)},iio.Grid.prototype.cellAt=function(a,b){return a.x?this.cells[Math.floor((a.x-this.left())/this.res.x)][Math.floor((a.y-this.top())/this.res.y)]:this.cells[Math.floor((a-this.left())/this.res.x)][Math.floor((b-this.top())/this.res.y)]},iio.Grid.prototype.foreachCell=function(a,b){for(var c=0;c<this.C;c++)for(var d=0;d<this.R;d++)if(!1===a(this.cells[c][d],b))return[d,c]},iio.App=function(){this.App.apply(this,arguments)},iio.inherit(iio.App,iio.Drawable),iio.App.prototype._super=iio.Drawable.prototype;iio.App.prototype.App=function(a,b,c){this._super.Drawable.call(this),this.app=this,this.canvas=a,this.ctx=a.getContext("2d"),this.canvas.parent=this,iio.canvas.prep_input(this.canvas),this.width=a.clientWidth||a.width,this.height=a.clientHeight||a.height,this.center=new iio.Vector(this.width/2,this.height/2),this.update_pos(),iio.apps.push(this),this.script=new b(this,c)},iio.App.prototype.update=function(){var a;if(this.onUpdate&&(a=this.onUpdate(this)),this.script.onUpdate){var b=this.script.onUpdate(this.script);void 0!==b&&(a=b)}return this.draw(),a},iio.App.prototype.trueVs=function(){this.vs=[new iio.Vector(-this.width/2,-this.height/2),new iio.Vector(this.width/2,-this.height/2),new iio.Vector(this.width/2,this.height/2),new iio.Vector(-this.width/2,this.height/2)];for(var a=[],b=0;b<this.vs.length;b++)a[b]=this.vs[b].clone();return a},iio.App.prototype.draw=function(a){if(this.keepDraws||this.ctx.clearRect(0,0,this.width,this.height),this.color&&(this.ctx.fillStyle=this.color.rgbaString(),this.ctx.fillRect(0,0,this.width,this.height)),this.objs.length>0)for(var b=0;b<this.objs.length;b++)(!this.clipObjs||this.objs[b].right()>0&&this.objs[b].left()<this.width&&this.objs[b].bottom()>0&&this.objs[b].top()<this.height)&&this.objs[b].draw&&this.objs[b].draw(this.ctx)},iio.App.prototype.eventVector=function(a){this.update_pos();var b=a.clientX,c=a.clientY;return a.touches&&a.touches[0]&&(b=a.touches[0].clientX,c=a.touches[0].clientY),new iio.Vector(b-this.pos.x,c-this.pos.y)},iio.App.prototype.update_pos=function(){var a=this.canvas.getBoundingClientRect();this.pos=new iio.Vector(a.left,a.top)},iio.App.prototype.stop=function(){return this.objs.forEach(function(a){a instanceof iio.Sound?a.stop():iio.cancelLoops(a)}),iio.cancelLoops(this),this.mainLoop&&iio.cancelLoop(this.mainLoop.id),this.clear(),this},iio.audioCtx=new(window.AudioContext||window.webkitAudioContext),iio.Sound=function(){this.Sound.apply(this,arguments)},iio.inherit(iio.Sound,iio.Interface),iio.Sound.prototype._super=iio.Interface.prototype,iio.Sound.prototype.Sound=function(a,b,c){var d=this;this.gainNode=iio.audioCtx.createGain(),this.gainNode.connect(iio.audioCtx.destination);var e=new XMLHttpRequest;e.open("GET",a,!0),e.responseType="arraybuffer",e.onload=function(){iio.audioCtx.decodeAudioData(e.response,function(a){d.buffer=a,b&&b(d,a)},c)},e.onerror=c,e.send()},iio.Sound.prototype.play=function(){if(this.set(iio.merge_args(arguments),!0),void 0!==typeof this.buffer)return this.source=iio.audioCtx.createBufferSource(),this.source.buffer=this.buffer,this.loop&&(this.source.loop=!0),this.gain&&(this.gainNode.gain.value=this.gain),this.source.connect(this.gainNode),this.source.start(this.delay||0),this},iio.Sound.prototype.stop=function(){return this.source&&this.source.disconnect(),this},iio.Loader=function(a){this.basePath=(a||".")+"/"},iio.loadSound=function(a,b,c){return new iio.Sound(a,b,c)},iio.loadImage=function(a,b,c){var d=new Image;return d.onload=b,d.onerror=c,d.src=a,d},iio.Loader.prototype.load=function(a,b){var c=a.length||Object.keys(a).length,d=0,e={},f=function(){d++,console.log(d),d===c&&b(e)},g=function(a,b,c){var d,g=c||a,h=this.basePath+a;if(iio.is.image(h))d=iio.loadImage;else{if(!iio.is.sound(h))return;d=iio.loadSound}var i=d(h,function(){e[g]=b?postloadProcess(i):i,console.log("success"),f()},f)}.bind(this);if(iio.is.string(a))g(a);else if(a instanceof Array)a.forEach(function(a){iio.is.string(a)?g(a):a.name&&g(a.name,a.callback,a.id)});else if(a.name)g(a.name,a.callback);else for(var h in a)if(a.hasOwnProperty(h)){var i=a[h];iio.is.string(i)?g(i,null,h):i.name?g(i.name,i.callback,h):g(h,i.callback,i.id)}return e},"undefined"!=typeof Box2D&&(Box2D.Dynamics.Joints.b2Joint.prototype.set=iio.Drawable.prototype.set,Box2D.Dynamics.Joints.b2Joint.prototype.convert_props=iio.Drawable.prototype.convert_props,Box2D.Collision.Shapes.b2Shape.prototype.set=iio.Drawable.prototype.set,Box2D.Collision.Shapes.b2Shape.prototype.convert_props=iio.Drawable.prototype.convert_props,Box2D.Collision.Shapes.b2CircleShape.prototype.set=iio.Drawable.prototype.set,Box2D.Collision.Shapes.b2CircleShape.prototype.convert_props=iio.Ellipse.prototype.convert_props,Box2D.Collision.Shapes.b2Shape.prototype.playAnim=iio.Shape.prototype.playAnim,Box2D.Collision.Shapes.b2Shape.prototype.stopAnim=iio.Shape.prototype.stopAnim,Box2D.Collision.Shapes.b2Shape.prototype.setSprite=iio.Shape.prototype.setSprite,Box2D.Collision.Shapes.b2Shape.prototype.nextFrame=iio.Shape.prototype.nextFrame,Box2D.Collision.Shapes.b2Shape.prototype.prevFrame=iio.Shape.prototype.prevFrame,Box2D.Collision.Shapes.b2Shape.prototype.orient_ctx=iio.Shape.prototype.orient_ctx,Box2D.Collision.Shapes.b2Shape.prototype.prep_ctx_color=iio.Shape.prototype.prep_ctx_color,Box2D.Collision.Shapes.b2Shape.prototype.prep_ctx_outline=iio.Shape.prototype.prep_ctx_outline,Box2D.Collision.Shapes.b2Shape.prototype.prep_ctx_lineWidth=iio.Shape.prototype.prep_ctx_lineWidth,Box2D.Collision.Shapes.b2Shape.prototype.prep_ctx_shadow=iio.Shape.prototype.prep_ctx_shadow,Box2D.Collision.Shapes.b2Shape.prototype.prep_ctx_dash=iio.Shape.prototype.prep_ctx_dash,Box2D.Collision.Shapes.b2Shape.prototype.finish_path_shape=iio.Shape.prototype.finish_path_shape,Box2D.Collision.Shapes.b2Shape.prototype.draw_obj=iio.Shape.prototype.draw_obj,Box2D.Collision.Shapes.b2Shape.prototype.draw=iio.Shape.prototype.draw,Box2D.Collision.Shapes.b2CircleShape.prototype.draw_shape=iio.Ellipse.prototype.draw_shape,Box2D.Collision.Shapes.b2PolygonShape.prototype.draw_shape=iio.Polygon.prototype.draw_shape,Box2D.Dynamics.Joints.b2Joint.prototype.orient_ctx=iio.Shape.prototype.orient_ctx,Box2D.Dynamics.Joints.b2Joint.prototype.prep_ctx_color=iio.Line.prototype.prep_ctx_color,Box2D.Dynamics.Joints.b2Joint.prototype.prep_ctx_lineWidth=iio.Line.prototype.prep_ctx_lineWidth,Box2D.Dynamics.Joints.b2Joint.prototype.prep_ctx_shadow=iio.Shape.prototype.prep_ctx_shadow,Box2D.Dynamics.Joints.b2Joint.prototype.prep_ctx_dash=iio.Shape.prototype.prep_ctx_dash,Box2D.Dynamics.Joints.b2Joint.prototype.draw_obj=iio.Shape.prototype.draw_obj,Box2D.Dynamics.Joints.b2Joint.prototype.draw=function(a){this.draw_obj(a)},Box2D.Dynamics.Joints.b2Joint.prototype.draw_shape=function(a){var b=this.GetBodyA(),c=this.GetBodyB(),d=b.m_xf,e=c.m_xf,f=d.position,g=e.position,h=this.GetAnchorA(),i=this.GetAnchorB();switch(a.beginPath(),this.m_type){case Box2D.Dynamics.Joints.b2Joint.e_distanceJoint:a.moveTo(h.x*this.app.b2Scale,h.y*this.app.b2Scale),a.lineTo(i.x*this.app.b2Scale,i.y*this.app.b2Scale);break;case Box2D.Dynamics.Joints.b2Joint.e_pulleyJoint:var j=this instanceof b2PulleyJoint?this:null,k=j.GetGroundAnchorA(),l=j.GetGroundAnchorB();a.moveTo(k.x*this.app.b2Scale,k.y*this.app.b2Scale),a.lineTo(h.x*this.app.b2Scale,h.y*this.app.b2Scale),a.moveTo(l.x*this.app.b2Scale,l.y*this.app.b2Scale),a.lineTo(i.x*this.app.b2Scale,i.y*this.app.b2Scale),a.moveTo(k.x*this.app.b2Scale,k.y*this.app.b2Scale),a.lineTo(l.x*this.app.b2Scale,l.y*this.app.b2Scale);break;case Box2D.Dynamics.Joints.b2Joint.e_mouseJoint:a.moveTo(h.x*this.app.b2Scale,h.y*this.app.b2Scale),a.lineTo(i.x*this.app.b2Scale,i.y*this.app.b2Scale);break;default:b!=this.m_groundBody&&(a.moveTo(f.x*this.app.b2Scale,f.y*this.app.b2Scale),a.lineTo(h.x*this.app.b2Scale,h.y*this.app.b2Scale)),a.moveTo(h.x*this.app.b2Scale,h.y*this.app.b2Scale),a.lineTo(i.x*this.app.b2Scale,i.y*this.app.b2Scale),c!=this.m_groundBody&&(a.moveTo(g.x*this.app.b2Scale,g.y*this.app.b2Scale),a.lineTo(i.x*this.app.b2Scale,i.y*this.app.b2Scale))}a.stroke()},Box2D.Dynamics.b2Body.prototype.draw=function(a){for(f=this.m_fixtureList;f;f=f.m_next){if(s=f.GetShape(),s.radius=s.m_radius*this.app.b2Scale,s.pos=new iio.Vector(this.m_xf.position.x*this.app.b2Scale,this.m_xf.position.y*this.app.b2Scale),s.rotation=this.GetAngle(),s.m_vertices){s.vs=[];for(var b=0;b<s.m_vertices.length;b++)s.vs.push(new iio.Vector(s.m_vertices[b].x*this.app.b2Scale,s.m_vertices[b].y*this.app.b2Scale))}s.draw&&s.draw(a)}},iio.App.prototype.addB2World=function(a,b){return this.b2World=a,this.b2Scale=30,this.b2Cnv=b||0,a},iio.App.prototype.b2Loop=function(a,b){return this.b2lastTime=this.b2lastTime||0,this.b2World&&!this.b2Pause&&this.b2World.Step(1/this.fps,10,10),iio.requestTimeout(a,this.b2lastTime,function(c,d){d[0].b2lastTime=c,d[0].b2Loop(a,b),d[0].b2World&&!d[0].b2Pause&&d[0].b2World.Step(1/a,10,10),b(c),d[0].b2DebugDraw&&d[0].b2DebugDraw?d[0].b2World.DrawDebugData():d[0].draw(d[0].b2Cnv),this.b2World&&d[0].b2World.ClearForces()},[this]),this},iio.App.prototype.pauseB2World=function(a){return void 0===a?void 0===this.b2Pause?this.b2Pause=!0:this.b2Pause=!this.b2Pause:this.b2Pause=a,this},iio.App.prototype.activateB2Debugger=function(a,b){if(a=a||!0,b=b||0,a)return this.b2DebugDraw=new Box2D.Dynamics.b2DebugDraw,this.b2DebugDraw.SetSprite(this.ctxs[b]),this.b2DebugDraw.SetDrawScale(this.b2Scale),this.b2DebugDraw.SetFillAlpha(.5),this.b2DebugDraw.SetLineThickness(1),this.b2DebugDraw.SetFlags(Box2D.Dynamics.b2DebugDraw.e_shapeBit|Box2D.Dynamics.b2DebugDraw.e_jointBit),this.b2World.SetDebugDraw(this.b2DebugDraw),this.b2DebugDraw},iio.App.prototype.b2BodyAt=function(a,b,c){function d(a){return!(a.GetBody().GetType()===Box2D.Dynamics.b2Body.b2_staticBody||!a.GetShape().TestPoint(a.GetBody().GetTransform(),b))&&a.GetBody()}void 0===b.x&&(b=new Box2D.Common.Math.b2Vec2(b,c));var e=new Box2D.Collision.b2AABB;return e.lowerBound.Set(b.x-.001,b.y-.001),e.upperBound.Set(b.x+.001,b.y+.001),this.b2World.QueryAABB(d,e)});